from itertools import chain

#naformátování vráceného několikabajtové hexa čísla na jednotlivé bity, pro možnost porovnání
def byte_parser(data):
    try:
        data = [data[i:i + 1] for i in range(0, len(data), 1)]
        new_data = []
        for i in range(0, len(data), 1):
            new_data.append([1 if x == '1' else 0 for x in "{0:08b}".format(int(hex(ord(data[i]))[2:], 16))])
        return list(chain.from_iterable(new_data))
    except:
        return -1

#definovaný formát dle datasheetu pro misc flag
def misc_flag_format(data):
    data = byte_parser(data)
    if data == -1:
        return -1
    keys = [
        "reserved7",
        "reserved6",
        "reserved5",
        "HomingActive",
        "ReverseLimitActive",
        "ForwardLimitActive",
        "PositionUncertain",
        "Energized"]
    return dict(zip(keys, data))

#definovaný formát dle datasheetu pro error status
def error_status_format(data):
    data = byte_parser(data)
    if data == -1:
        return -1
    keys = [
        "SafeStartViolation",
        "CommandTimeout",
        "SerialError",
        "RequiredInputInvalid",
        "KillSwitchActive",
        "LowVIN",
        "MotorDriverError",
        "InternationallyDeEnergized",
        "ERRLineHigh_or_reserved7",
        "ERRLineHigh_or_reserved6",
        "ERRLineHigh_or_reserved5",
        "ERRLineHigh_or_reserved4",
        "ERRLineHigh_or_reserved3",
        "ERRLineHigh_or_reserved2",
        "ERRLineHigh_or_reserved1",
        "ERRLineHigh_or_reserved0"]
    return dict(zip(keys, data))