from MM_initialization import axis_X, axis_Y, axis_Z, system_info,device_info
from MM_mqtt import client, topic_path_main, topic_path_control, topic_path_classification
from MM_Axis_class import Axis
import paho.mqtt.client as mqtt

# Axis variable
def TargetPosition(target, value):
    try:
        if device_info.connect_device != device_info.initialized_device: #pokud se připojené zařízení nerovnají s inicializovanými, nepokračuj a pošli informaci
            client.publish("MIXANM/System/I2C/Info/StatusBar","Connected devices != inicialized devices")
            return False
        else: 
            client.publish("MIXANM/System/I2C/Info/StatusBar","System is ready")
        if system_info.initialized: #pokud je systém inicializovaný, pokračuj
            value = float(value)
            #výběr příslušné osy, pro předání cílové polohy
            if target == "AxisX":
                if int(axis_X.state_var["Control"]) == 1:
                    axis_X.set_target_position(value)
                    client.publish("MIXANM/Control/Primar/AxisX/TargetPositionMM",str(round((int(axis_X.state_var["RangeMM"])/2) * (value/100),2)))
                elif int(axis_X.state_var["Control"]) == 0:
                    _set_actual_position(axis_X, client)
            elif target == "AxisY":
                if int(axis_Y.state_var["Control"]) == 1:
                    axis_Y.set_target_position(value)
                    client.publish("MIXANM/Control/Primar/AxisY/TargetPositionMM",str(round((int(axis_Y.state_var["RangeMM"])/2) * (value/100),2)))  
                elif int(axis_Y.state_var["Control"]) == 0:
                    _set_actual_position(axis_Y, client)
            elif target == "AxisZ":
                if int(axis_Z.state_var["Control"]) == 1:
                    axis_Z.set_target_position(value)
                    client.publish("MIXANM/Control/Primar/AxisZ/TargetPositionMM",str(round((int(axis_Z.state_var["RangeMM"])/2) * (value/100),2)))
                elif int(axis_Z.state_var["Control"]) == 0:
                    _set_actual_position(axis_Z, client)
            else:
                pass
        else:
            client.publish("MIXANM/System/I2C/Info/StatusBar","System not initialized!")
            pass
    except:
        pass

def _set_actual_position(axis: Axis, mqtt_client: mqtt.Client):
    actual_position = axis.state_var["ActualPosition"]
    topic = f'{topic_path_main}/{topic_path_control}/{topic_path_classification}/{axis.name}/TargetPosition'
    try:
        mqtt_client.publish(topic, str(actual_position))
    except:
        pass

def Control(target, value):
    if target == "AxisX":
        axis_X.state_var["Control"] = value
    elif target == "AxisY":
        axis_Y.state_var["Control"] = value
    elif target == "AxisZ":
        axis_Z.state_var["Control"] = value
    else:
        pass

def D1Control(target, value):
    _set_motors("D1Control", target, value)   

def D2Control(target, value):
    _set_motors("D2Control", target, value)
    
def _set_motors(control: str, target: str, value):
    if target == "AxisX":
        axis_X.motors[control] = value  
    elif target == "AxisY":
        axis_Y.motors[control] = value
    elif target == "AxisZ":
        axis_Z.motors[control] = value
    else:
        pass

def RangeMM(target, value):
    if target == "AxisX":
        axis_X.state_var["RangeMM"] = value
    if target == "AxisY":
        axis_Y.state_var["RangeMM"] = value
    if target == "AxisZ":
        axis_Z.state_var["RangeMM"] = value
    
def switcher_axis(topic, target, value):
    axis_var = {
        "TargetPosition": TargetPosition,
        "Control": Control,
        "D1Control": D1Control,
        "D2Control": D2Control,
        "RangeMM": RangeMM,}

    result = axis_var.get(topic, 0)
    if result != 0:
        result(target, value)

if __name__ == "__main__":
    pass