from MM_initialization import axis_X, axis_Y, axis_Z, system_info, mqtt_init_public, device_info
from MM_mqtt import client
import time
#from MM_Axis_class import
from MM_slave_counter import slave_counter_i2c


def slave_driver_control(init_comm = False):
    device = slave_counter_i2c(0)["address"]
    device_info.connect_device = device

    if 10 in device: 
        axis_X.motors["D1Control"] = 1
        if init_comm == True: device_info.initialized_device.append(10)
        client.publish("MIXANM/Control/Primar/AxisX/isActive1","ON")
    else:
        axis_X.motors["D1Control"] = 0
        client.publish("MIXANM/Control/Primar/AxisX/isActive1","OFF")
    if 11 in device: 
        axis_X.motors["D2Control"] = 1
        if init_comm == True: device_info.initialized_device.append(11)
        client.publish("MIXANM/Control/Primar/AxisX/isActive2","ON")
    else:
        axis_X.motors["D2Control"] = 0
        client.publish("MIXANM/Control/Primar/AxisX/isActive2","OFF")

    if 20 in device: 
        axis_Y.motors["D1Control"] = 1
        if init_comm == True: device_info.initialized_device.append(20)
        client.publish("MIXANM/Control/Primar/AxisY/isActive1","ON")
    else:
        axis_Y.motors["D1Control"] = 0
        client.publish("MIXANM/Control/Primar/AxisY/isActive1","OFF")
    if 21 in device: 
        axis_Y.motors["D2Control"] = 1
        if init_comm == True: device_info.initialized_device.append(21)
        client.publish("MIXANM/Control/Primar/AxisY/isActive2","ON")
    else:
        axis_Y.motors["D2Control"] = 0
        client.publish("MIXANM/Control/Primar/AxisY/isActive2","OFF")

    if 30 in device: 
        axis_Z.motors["D1Control"] = 1
        if init_comm == True: device_info.initialized_device.append(30)
        client.publish("MIXANM/Control/Primar/AxisZ/isActive1","ON")
    else:
        axis_Z.motors["D1Control"] = 0
        client.publish("MIXANM/Control/Primar/AxisZ/isActive1","OFF")
    if 31 in device: 
        axis_Z.motors["D2Control"] = 1
        if init_comm == True: device_info.initialized_device.append(31)
        client.publish("MIXANM/Control/Primar/AxisZ/isActive2","ON")
    else:
        axis_Z.motors["D2Control"] = 0
        client.publish("MIXANM/Control/Primar/AxisZ/isActiv2","OFF")

def Inicialization(target, value):
    device_info.initialized_device.clear()
    client.publish("MIXANM/System/I2C/Info/InicializedAddress","-")
    slave_driver_control(True)

    try:
        if int(value):
            mqtt_init_public(client)
            time.sleep(1)

            successful_x, successful_y, successful_z = False, False, False

            if axis_X.is_active():
                successful_x = axis_X.initialize_position()
                if not successful_x:
                    client.publish("MIXANM/System/I2C/Info/StatusBar","Some error during Axis X initialization...")
            else:
                successful_x = True
            
            if axis_Y.is_active():
                successful_y = axis_Y.initialize_position()
                if not successful_y:
                    client.publish("MIXANM/System/I2C/Info/StatusBar","Some error during Axis Y initialization...")
            else:
                successful_y = True

            if axis_Z.is_active():
                successful_z = axis_Z.initialize_position()
                if not successful_z:
                    client.publish("MIXANM/System/I2C/Info/StatusBar","Some error during Axis Z initialization...")
            else:
                successful_z = True

            if successful_x & successful_y & successful_z:
                system_info.initialized = True
                msg = "System initialized!"
                client.publish("MIXANM/System/I2C/Info/StatusBar", str(msg))
                client.publish("MIXANM/System/I2C/Info/InicializedAddress",str(device_info.initialized_device))
                mqtt_init_public(client)
            else:
                system_info.initialized = False
                
        else:
            client.publish("MIXANM/System/I2C/Info/StatusBar","Some Error in init...")
            system_info.initialized = False
            mqtt_init_public(client)
    except:
        pass

def switcher_system(topic, target, value):
    axis_var = {
        "Inicialization": Inicialization}

    result = axis_var.get(topic, 0)

    if result != 0:
        result(target, value)

if __name__ == "__main__":
    pass
